
#pragma once

#include "BuddyTreeCtrl.h"


typedef std::map<std::pair<std::wstring, int>, Node*> BuddyUserIdMap;


class FavoriteViewItem;
class MainFrame;

class FavoriteView
{
public:
	FavoriteView(void);
	~FavoriteView(void);

	void SetController(FavoriteController* favoriteController);
	/*CWnd & GetWindowHandle()
	{
		return m_ctrlFavoriteTree;
	}
*/

	CBuddyTreeCtrl* GetTreeCtrl()
	{
		return m_pDuiList;
	}

	void SetList(CBuddyTreeCtrl* pBuddyList);
	void Move(LPRECT lpRect);
	void RedrawGroup();

	void DeleteAllItems();
	//void AddGroup(LPCWSTR strGroupName,  const IGTBuddyGroup* pGroup, bool bEditLabel, bool bExpand = false);
	void AddGroup574(LPCWSTR strGroupName,  const IGTBuddyGroup* pGroup, bool bEditLabel, bool bExpand = false);
	int GetGroupID(const CString strGroupName);
	void DeleteGroup(int nGroupID);
	//void AddBuddy(const IGTBuddyUser* pUser, int nGroupID);
	void AddBuddy574(const IGTBuddyUser* pUser, int nGroupID);
	void ResortBuddyInGroup(int nGroupID);

	void UpdataAllBuddyImage();
	void DeleteBuddy(LPCWSTR strUserId, int nGroupId);
	void GroupResort();
	void SetEmptyText(const CString& strEmptyText);

	std::vector<Node*>	GetSelectedItems(void);
	const std::vector<const IGTBuddyUser *> SelectedBuddyUsers();
	const std::vector<const IGTBuddyGroup *> SelectedGroups();
	const std::vector<Node*> SelectedGroupItems();
	const std::vector<Node*> SelectedBuddyItems();

	std::vector<Node*>	GetAllItems(void);
	const std::vector<Node*> AllGroupItems();
	const std::vector<const IGTBuddyGroup *> AllGroups();

	bool IsGroupSelected() const;
	bool IsBuddySelected() const;

	bool IsExistGroup(LPCWSTR strUserID, int nGroupID);

	void OnRButtonEvent( bool bDown, int nIndex );

	const IGTBuddyUser* GetSelectedBuddy() const;
	const IGTBuddyGroup* GetSelectedGroup() const;

	void EditGroupLabelOn(int nGroupID = -1 );
	void EditGroupLabel( Node* hItem );

	void UpdateGroupName(const IGTBuddyGroup* pGroup, LPCWSTR displayText);	
	void UpdateStaus(LPCWSTR strUserId, const IGTBuddyUser *pUser, const NE_MEMBER_DATA* data);
	void UpdateAllBuddyDisplayNames();

	void MenuMoveBuddy(UINT nCmdID, int nMenuStartID);
	void MenuCopyBuddy(UINT nCmdID, int nMenuStartID);
	const CString GetItemDisplayText(const IGTBuddyUser* pUser);
	const CString GetItemWorkStatusText(const IGTBuddyUser* pUser);

	void ExpandRecentContactGroup();
	void ExpandBuddyGroup();
	int HitTestGroupId() const;
	//void AddGroup(LPCWSTR strGroupName, const IGTBuddyGroup* pGroup, bool bEditLabel, bool bExpand);
	BuddyUserIdMap*  GetUsrIdMap(){return &m_userIdMap;};
private:
	bool IsGroup(Node* pNode);
	const CString GetDisPlayName(const NE_MEMBER_DATA* data);
	const CString GetDisPlayEmpInfo(const NE_MEMBER_DATA* data);
	const CString GetDisPlayTelInfo(const NE_MEMBER_DATA* data);
	void SetIcon(Node* hItem, GTUserStatusType status);
	void RepeatHitemFilter( std::vector<Node*>& vec_in,  std::vector<Node*>& vec_out);
	bool IsExistBuddy(Node* hParentItem,LPCWSTR strUserId);
	//BOOL ReplaceBubbyUserInItem(LPCWSTR strUserId);
	//CBuddyTreeCtrl m_ctrlFavoriteTree;
	CBuddyTreeCtrl* m_pDuiList;

	CImageList	m_ImageList;
	BuddyUserIdMap m_userIdMap; 
	FavoriteController* m_favoriteController;
	CCriticalSection	m_csFavoriteView;
	std::map<int, CString> m_groupIdMap574;
};
